# BRAIN TUMOR CLASSIFICATION

A machine learning package that diagnoses brain tumors from MRI (Magnetic Resonance Imaging) scans. It detects if there is a tumor and then classify it in terms of grade, type, and specific location. This program uses a **neural network algorithm** to detect tumors/no tumors with a validation accuray of 92% and a validation recall of 98%.

## Data set and its description  

| Data              | Description                                                                                    |
|-------------------|------------------------------------------------------------------------------------------------|
| Image             | the image object(jpg format)                                                                   |
| Label             | class options of each image (glioma, meningioma, no tumor, and pituitary.)                     |

## Dependencies and packages  

1. numpy>=1.20.0,<1.21.0
2. python = 3.10
3. pandas = 2.2.2
4. scikit-learn = 1.4.2
5. pydantic = 2.7.0
6. strictyaml = 1.7.3
7. tensorflow = 2.16.1
8. scikeras = 0.13.0
9. tensorflow-datasets = 4.9.4
10. pillow = 10.3.0
11. pydantic-settings = 2.2.1
12. fastapi = 0.110.3
13. uvicorn = 0.29.0
14. loguru = 0.7.2
15. python-multipart = 0.0.9

## Source code link  

Source code link:
[Github link](https://github.com/chibuikeeugene/brain_tumor_classification_cnn_model.git)

Python index package:
[Pypi link](https://pypi.org/project/braintumor-model-package/)
